/* soundblaster_audio.c */

/* $Author: espie $
 * $Id: soundblaster_audio.c,v 1.4 1992/07/22 14:50:25 espie Exp espie $
 * $Revision: 1.4 $
 * $Log: soundblaster_audio.c,v $
 * Revision 1.4  1992/07/22  14:50:25  espie
 * defs.h.
 *
 * Revision 1.3  1992/07/14  14:23:41  espie
 * Small changes.
 * \.
 *
 * Revision 1.2  1992/07/14  13:20:53  espie
 * Added stereo option (kind of).
 *
 * Revision 1.1  1992/06/24  06:24:17  steve
 * Initial revision
 */

#include <malloc.h>
#include <stdio.h>
#include "defs.h"
#include "extern.h"
#include <i386at/sblast.h>

LOCAL char *id = "$Id: soundblaster_audio.c,v 1.4 1992/07/22 14:50:25 espie Exp espie $";

static unsigned char *buffer;/* buffer for ready-to-play samples */
static int buf_index;   /* can't call this index, conflicts with index(3) */
FILE *audio;            /* /dev/sb_dsp */

/* are we playing stereo or not ? */
static int stereo;
/* 256th of primary/secondary source for that side. */
static int primary, secondary;

void set_mix(percent)
int percent;
    {
    percent *= 256;
    percent /= 100;
    primary = percent;
    secondary = 512 - percent;
    }

int open_audio(f, s)
int f;
int s;
    {
    audio = fopen("/dev/sb_dsp", "w");
    if (!audio)
        {
        perror("Error opening audio device");
        exit(10);
        }

    stereo = s;
    if (ioctl(fileno(audio), DSP_IOCTL_STEREO, stereo) == -1)
        {
        perror("Error setting stereo/mono");
        exit(1);
        }

    if (stereo)
        f *= 2;     /* XXX Stereo takes twice the speed */

    if (f == 0)
        f = -1;     /* read current frequency from driver */

    if (ioctl(fileno(audio), DSP_IOCTL_SPEED, &f) == -1)
        {
        perror("Error setting frequency");
        exit(1);
        }

    buffer = malloc(sizeof(SAMPLE) * f);    /* Stereo makes x2 */
    buf_index = 0;

    if (stereo)         /* tacky, I know.. */
        return f/ 2;
    else
        return f;
    }

void output_samples(left, right)
int left, right;
    {
    if (stereo)
        {
        buffer[buf_index++] = (((left * primary + right * secondary) / 256)
             + (1 << 15)) >> 8;
        buffer[buf_index++] = (((right * primary + left * secondary) / 256)
             + (1 << 15)) >> 8;
        }
    else
        buffer[buf_index++] = (left + right + (1 << 15)) >> 8;
    }

void flush_buffer()
    {
    if (fwrite(buffer, sizeof(*buffer), buf_index, audio) != buf_index)
        fprintf(stderr, "fwrite didn't write all the bytes?\n");
    buf_index = 0;
    }

/*
 * Closing the BSD SBlast sound device waits for all pending samples to play.
 * I think SysV aborts, so you might have to flush manually with ioctl()
 */
void close_audio()
    {
    fclose(audio);
    free(buffer);
    }
